{
module SetPiLexer where
}

%wrapper "monad"

$digit = 0-9   -- digits
$alpha = [a-zA-Z]  -- alphabetic characters
$identChar = [a-zA-Z0-9_]
tokens :-

<0> $white+;
<0> "(*" {begin comment}
<comment> "*)" {begin 0}
<comment> [\n.]*;
<0> "agree"  {\p s -> T Agree p}
<0> "fun"    {\p s -> T Fun p}
<0> "pred" 	 {\p s -> T Pred p}
<0> "reduc"  {\p s -> T Reduc p}
<0> "set"    {\p s -> T Set p}
<0> "forall" {\p s -> T ForAll p}
<0> "in"     {\p s -> T In p}
<0> "out"    {\p s -> T Out p}
<0> "let"    {\p s -> T Let p}
<0> "if"   	 {\p s -> T If p}
<0> "inj-agree" {\p s -> T InjAgree p}
<0> "inj-event" {\p s -> T InjEvent p}
<0> "then" 	 {\p s -> T Then p}
<0> "else"	 {\p s -> T Else p}
<0> "lock"	 {\p s -> T Lock p}
<0> "unlock"	 {\p s -> T Unlock p}
<0> "event"  {\p s -> T Event p}
<0> "new"	 {\p s -> T New p}
<0> "and"	 {\p s -> T And p}
<0> "or"	 {\p s -> T Or p}
<0> "not"	 {\p s -> T Not p}
<0> "private"	 {\p s -> T Private p}
<0> "update" {\p s -> T Update p}
<0> "query"  {\p s -> T Query p}
<0> "process" {\p s -> T Process p}
<0> "select" {\p s -> T Select p}
<0> "where"  {\p s -> T Where p}
<0> "==>"	 {\p s -> T Implies p}
<0> "<>"	 {\p s -> T Neq p}
<0> "=" 	 {\p s -> T Eq p}
<0> "("	 {\p s -> T OpenPar p}
<0> ")"	 {\p s -> T ClosePar p}
<0> "{"	 {\p s -> T OpenBrace p}
<0> "}"	 {\p s -> T CloseBrace p}
<0> "["	 {\p s -> T OpenBracket p}
<0> "]"  {\p s -> T CloseBracket p}
<0> ";"	 {\p s -> T SemiColon p}
<0> ":"	 {\p s -> T Colon p}
<0> ","	 {\p s -> T Comma p}
<0> "."	 {\p s -> T Dot p}
<0> "!"	 {\p s -> T Bang p}
<0> "|" 	 {\p s -> T Par p}
<0> $alpha$identChar* {\p s -> T (Ident s) p}

{
data PiToken =
    Agree
  | Fun
  | Pred
  | Reduc
  | Set
  | ForAll
  | In
  | Out
  | Let
  | If
  | InjAgree
  | InjEvent
  | Then
  | Else
  | Lock
  | Unlock
  | Event
  | New
  | And
  | Or
  | Not
  | Update
  | Query
  | Private
  | Select
  | Where
  | Implies
  | Neq
  | Eq
  | OpenPar
  | ClosePar
  | OpenBrace
  | CloseBrace
  | OpenBracket
  | CloseBracket
  | SemiColon
  | Colon
  | Comma
  | Dot
  | Bang
  | Par
  | Process
  | EOF
  | Ident String
    deriving (Eq, Show)

data Token = T { tok :: PiToken, posn :: AlexPosn }

alexEOF = do
  -- p <- alex_pos
  return (T EOF (AlexPn 0 0 0 ))
}
